    console.log("Loading mraidext.js");

    (function () {
        // Root bridge object handler
        var mraidext = window.mraid_ext = {};

        //////////////////////////////////////////////////////////////////////////////////////////////////
        mraidext.start = function () {
            console.log("Firing start event!");
            window.mraidbridge.executeNativeCallWithScheme('mraidext', 'start');
        };

        mraidext.credit = function (data) {
            console.log("mraidext.credit");
            console.log("firing credit event! with data: " + stringify(data));
            var call = "mraidext://credit";

            if (data && data.payload && data.signature) {
                window.mraidbridge.executeNativeCallWithScheme('mraidext', 'credit', 'payload', data.payload, 'signature', data.signature);
            } else {
                window.mraidbridge.executeNativeCallWithScheme('mraidext', 'credit');
            }
        };

        mraidext.finish = function () {
            console.log("firing finish event!");
            window.mraidbridge.executeNativeCallWithScheme('mraidext', 'finish');
        };

        mraidext.toast = function (message, duration) {
            console.log("mraidext.toast");
            window.mraidbridge.executeNativeCallWithScheme('mraidext', 'toast', 'message', message, 'duration', duration);
        };

        mraidext.report = function (type, params) {
            console.log("mraidext.report - " + type);
            var paramsType = Object.prototype.toString.call(params).match(/^\[object\s(.*)\]$/)[1].toLowerCase();
            if (paramsType === "object") {
                window.mraidbridge.executeNativeCallWithScheme('mraidext', 'report', 'type', type, 'params', JSON.stringify(params));
            } else {
                window.mraidbridge.fireErrorEvent('params expected to be object, actual type ' + paramsType, 'mraidext.report');
            }
        };

    }());
